#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

/* this many replies are supported at one time */
#define MAX_HOSTS 100

/* role: wait for connection */
/* 
 * port: TCP port to listen on
 * timeout: to wait in seconds for incoming, before returning anyway
 * mcast: multicast group to join
 *
 * return: 
 * -1 for error
 * IP address in *peer
 */
int passive(int port, int timeout, const char *maddr, struct in_addr *peer);

/* role: try to build up a connection */
/* 
 * hostlist: IP address string list of potential peers
 * numhosts: #elements in hostlist
 * port: tcp port to connect to
 * timeout: total time to spend trying
 * 
 * return: 
 * -1 for error
 * IP address in *peer
 * */
int active(struct in_addr *hostlist, int numhosts, int port, int timeout, struct in_addr *peer);

/* build a list of hosts or active() to connect with */
int build_host_list(struct in_addr * hostlist, int *numhosts, const char *maddr, int timeout);

/* set a numeric /proc variable */
long get_sysctl_status(const char *path);

/* get the value of a numeric /proc variable */
long set_sysctl_status(const char *path, long value);
