#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#include "pair.h"

/* The use of SYS_sysctl is discouraged in favor of
   the /proc/sys interface, see sysctl(2) 
   These two functions get/set a numeric value from procfs */

long get_sysctl_status(const char *path) {
	int f; /* file handle */
	char buf[32];
	memset(buf,0,32);
	if (0>(f=open(path, O_RDONLY))) {
		perror(path);
		exit(errno);
	}
	if(read(f,buf,31)) {
		close(f);
		return atol(buf);
	} else {
		close(f);
		perror(path);
		exit(errno);
	}

	/* control never reaches here */
	return -999;
}

long set_sysctl_status(const char *path, long value) {
	int f; /* file handle */
	char buf[32];
	int buflen=0;
	buflen=snprintf(buf,32,"%ld",value);
	if (0>(f=open(path, O_WRONLY))) {
		perror(path);
		exit(errno);
	}
	if(write(f,buf,(size_t)buflen)) {
		close(f);
		return 0;
	} else {
		close(f);
		perror(path);
		exit(errno);
	}

	/* control never reaches here */
	return -999;
}
